<template>
  <form novalidate class="md-layout md-alignment-top-center">
    <md-card class="md-layout-item md-size-33 md-small-size-50 md-xsmall-size-100">
      <md-card-header>
        <div class="md-title">Register</div>
      </md-card-header>

      <md-card-content>
        <md-field>
          <label for="name">Name</label>
          <md-input
            type="text"
            name="name"
            id="name"
            autocomplete="name"
            v-model="name"
            :disabled="sending"
          />
        </md-field>
        <md-field>
          <label for="email">Email</label>
          <md-input
            type="email"
            name="email"
            id="email"
            autocomplete="email"
            v-model="email"
            :disabled="sending"
          />
        </md-field>
        <md-field>
          <label for="name">Password</label>
          <md-input
            type="password"
            name="password"
            id="password"
            v-model="password"
            :disabled="sending"
          />
        </md-field>
        <md-field>
          <label for="name">Confirm Password</label>
          <md-input
            type="password"
            v-model="password"
            :disabled="sending"
          />
        </md-field>
        <md-checkbox v-model="resident" :disabled="sending">Passwordless</md-checkbox>
      </md-card-content>

      <md-progress-bar md-mode="indeterminate" v-if="sending" />

      <md-card-actions>
        <md-button
          type="submit"
          class="md-primary"
          :disabled="sending"
          v-on:click="register()"
        >Register</md-button>
      </md-card-actions>
    </md-card>
    <Communication :path="path" :message="message" :detail="detail" :working="working" @next="register()" />

    <md-snackbar :md-active.sync="registered">You have been registered!</md-snackbar>
  </form>
</template>

<script>
import { solveRegistrationChallenge } from "@webauthn/client";
import Communication from "@/components/Communication.vue";
import { CommunicationDirection } from "./communication-direction";
import { extractCredential } from "@/utils";
import { store } from "../store";

export default {
  name: "Register",
  components: {
    Communication
  },
  computed: {
    debug: function() {
      return store.debug;
    }
  },
  methods: {
    steps: function() {
      return [
        this.register_s0,
        this.register_s1,
        this.register_s2,
        this.register_s3,
        this.register_s4,
        this.register_s5
      ];
    },
    register: async function() {
      this.working = true;
      if (this.debug) {
        await this.steps()[this.step]();
      } else {
        for (let step in [0, 1, 2, 3, 4, 5]) {
          await this.steps()[step]();
        }
      }
      this.working = false;
    },
    register_s0: async function() {
      // ****************************
      // Send Regsitration request
      // ****************************
      this.sending = true;
      this.path = CommunicationDirection.BROWSER_2_SERVER;
      this.message = { name: this.name, email: this.email, password: this.password };
      this.step = 1;
    },
    register_s1: async function() {
      // **************************
      // Get challenge from Backend
      // **************************
      let requestFromServer = await fetch(
        process.env.VUE_APP_API + "/register/init",
        {
          method: "POST",
          headers: {
            "content-type": "application/json"
          },
          body: JSON.stringify({ name: this.name, email: this.email, password: this.password })
        }
      ).then(response => response.json());
      this.path = CommunicationDirection.SERVER_2_BROWSER;
      this.message = requestFromServer;
      this.challenge = requestFromServer.challenge;
      this.step = 2;
    },
    register_s2: async function() {
      // ********************************
      // Create Request for Authenticator
      // ********************************
      const registerRequest = {
        challenge: this.challenge,
        rp: {
          id: window.location.hostname,
          name: "Benefiz"
        },
        user: {
          id: btoa(this.email),
          displayName: this.name,
          name: this.name
        },
        attestation: "direct",
        pubKeyCredParams: [
          {
            type: "public-key",
            alg: -7
          }
        ],
        authenticatorSelection: {
          requireResidentKey: this.resident
        }
      };
      this.path = CommunicationDirection.BROWSER_2_KEY;
      this.message = registerRequest;
      this.registerRequest = registerRequest;
      this.step = 3;
    },
    register_s3: async function() {
      // ***********************************
      // Store credentials in Authenticator
      // ***********************************
      const credentials = await solveRegistrationChallenge(
        this.registerRequest
      );
      this.path = CommunicationDirection.KEY_2_BROWSER;
      this.message = credentials;
      this.detail = extractCredential(credentials);
      this.credentials = credentials;
      this.step = 4;
    },
    register_s4: async function() {
      // **************************************
      // Send authenticator response to server
      // **************************************
      this.path = CommunicationDirection.BROWSER_2_SERVER;
      this.message = {... this.message};
      this.detail = undefined;
      this.step = 5;
    },
    register_s5: async function() {
      // ***************************
      // Send credentials to Backend
      // ***************************
      const response = await fetch(
        process.env.VUE_APP_API + "/register/challenge",
        {
          method: "POST",
          headers: {
            "content-type": "application/json"
          },
          body: JSON.stringify(this.credentials)
        }
      ).then(response => response.json());

      this.registered = response.registered;
      this.path = CommunicationDirection.SERVER_2_BROWSER;
      this.message = response;
      this.sending = false;
      this.step = 0;
    }
  },
  data: () => {
    return {
      name: "arnaud",
      email: "arnaud.locquet@benefiz.fr",
      password: "s3cur3d",
      resident: false,
      registered: false,
      sending: false,
      working: false,
      message: {},
      detail: undefined,
      path: undefined,
      challenge: "",
      registerRequest: {},
      credentials: {},
      step: 0
    };
  },
  filters: {
    pretty: function(value) {
      return JSON.stringify(value, null, 2);
    }
  },
  errorCaptured(err) {
    console.error(err);
    this.message = { error: err.message };
    this.sending = false;
    this.working = false;
    this.detail = undefined;
    this.step = 0;
  }
};
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
.md-layout {
  padding-top: 50px;
}
</style>
